import {Avatar} from '@mui/material';
import styled from 'styled-components';
import {connect} from "react-redux";
import {useEffect} from "react";
import {changeAuthData, changeAuthDataAsync} from "../store/actionCreators/authActionCreators";
import {useNavigate} from "react-router-dom";
import avatar from "../assets/img/avatarGolub.jpg"

const HeaderWrapper = styled.div`
  display: flex;
  justify-content: space-around;
  box-shadow: 0px 10px 13px -7px #000000, 5px 5px 15px 5px rgba(41, 78, 255, 0);
`

const OwnerHeader = (props) => {
    const navigate = useNavigate();

    useEffect(() => {
        // props.changeAuthDataAsync({login, password, "ownerData", navigateCallback: navigate})
    }, [props.id])

    const Logo = () => {
        return (
            <p>HIPSTARGAM</p>
        )
    }
    const logout = () => {
        localStorage.authToken = "";
        props.changeAuthData({
            token: "",
            user: ""
        })
        navigate("/auth")

    }

    return (
        <HeaderWrapper>
            <Logo/>

            <Avatar  src={avatar} alt={"avatar"} sx={{border:"1px solid grey"}}/>


            <p>Hello</p>
            <button onClick={logout}>Logout</button>

        </HeaderWrapper>
    )
};

const mapStateToProps = (state) => {
    console.log(state)
    return {
        id: state.auth.user.sub.id
    }
}
const mapDispatchToProps = (dispatch) => {
    return {
        changeAuthData: (authData) => dispatch(changeAuthData(authData)),
        changeAuthDataAsync: (authData) => dispatch(changeAuthDataAsync(authData))
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(OwnerHeader);