import {connect} from "react-redux";
import styled from 'styled-components';
import {useEffect} from "react";
import {setActiveUserDataAsync} from "../store/actionCreators/authActionCreators";
import avatar from "../assets/img/avatarGolub.jpg"

const UserContentWrapper = styled.div`
  margin-top: 30px;
  width: 100%;
`
const AvatarBlock = styled.div`
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  width: 40%;
`
const PostsContainer = styled.div`
  display: flex;
  flex-direction: column;
`
const UserInfoWrapper = styled.div`
  display: flex;
  width: 100%;
`
const UserInfoBlockWrapper = styled.div`
  display: flex;

  justify-content: space-around;
  width: 60%;
`
const UserInfoBlockStyled = styled.div`
  display: flex;
  flex-direction: column;
  align-items: center;
  width: 33%;
`
const AvatarWrapper = styled.div`
  width: 100px;
  height: 100px;
  border-radius: 50%;
  border: 1px solid grey;
  overflow: hidden;
  display: flex;
  align-items: center;
`

function UserContent(props) {

    useEffect(() => {
        if (!props.activeUser) {
            props.setActiveUserDataAsync(props.id)
        }
    })

    console.log(props)

    const UserInfoBlock = ({count, description}) => {
        return (<UserInfoBlockStyled>
            <p>{count?.count ? count.count : 0}</p>
            <p>{description}</p>
        </UserInfoBlockStyled>)
    }

    return (
        <>
            {props.activeUser && <UserContentWrapper>
                <UserInfoWrapper>
                    <AvatarBlock>
                        <AvatarWrapper>
                            <img style={{height:"100%"}} src={props.activeUser.avatar ? props.activeUser.avatar : avatar} alt={"avatar"}/>
                        </AvatarWrapper>
                        <h2>{props.activeUser.login}</h2>
                    </AvatarBlock>
                    <UserInfoBlockWrapper>
                        <p>кол-во публикаций</p>
                        <UserInfoBlock count={props.activeUser.followers} description={"followers"}/>
                        <UserInfoBlock count={props.activeUser.following} description={"followings"}/>
                    </UserInfoBlockWrapper>
                </UserInfoWrapper>

                <PostsContainer>
                    посты
                </PostsContainer>


            </UserContentWrapper>
            }
        </>
    )
};

const mapStateToProps = (state) => {

    return {
        id: state.auth.user.sub.id,
        activeUser: state.activeUser,

    }
}
const mapDispatchToProps = (dispatch) => {
    return {
        setActiveUserDataAsync: (id) => dispatch(setActiveUserDataAsync(id))
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(UserContent);