
const getGQL = (url) => (query, variables) =>{
    return fetch(url, {
        method: "POST",
        // mode: 'no-cors',
        headers: {
            "Content-Type": "application/json",
            ...(localStorage.authToken
                ? { Authorization: "Bearer " + localStorage.authToken }
                : {}),
            'Access-Control-Allow-Origin': "*"
        },
        body: JSON.stringify({ query, variables }),
    })
        .then((res) => {
            // console.log(res)
            // return res.json()
            return res;
        })
        // .then((data) => {
        //     console.log(data)
        //     if (data.data) {
        //         console.log(data.data) //token
        //
        //         return Object.values(data.data)[0];
        //     } else throw new Error(JSON.stringify(data.errors));
        // });
}

// const backendURL = 'http://hipstagram.asmer.fs.a-level.com.ua'
// const backendURL = 'http://hipstagram.node.ed.asmer.org.ua'

export const gql = getGQL("/graphql");


export const gqlRegistration=(login,password)=>gql(`mutation register($login: String!, $password: String!){
                createUser(login: $login, password: $password) {
                    _id login
                }
            }`, {login: String(login), password: String(password)}
)

export const actionAboutMe = (_id) =>gql(`query AboutMe($userId:String){
            UserFindOne(query:$userId)
            {
              _id createdAt login nick avatar{_id url} 
              followers{_id login nick avatar{_id url}} 
              following{_id login nick avatar{_id url}}
            }
          }`,
            {
                userId: JSON.stringify([{ _id }]),
            },
    )

export const gqlLogin=(login,password)=>gql(
    `query login($login: String!, $password: String!){
        login(login: $login, password: $password)
        }`,
        {login: String(login), password: String(password)}
)